#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif

#ifndef DOS_NOTIFY_H
#include <dos/notify.h>
#endif

#ifndef DOS_DOSTAGS_H
#include <dos/dostags.h>
#endif

#ifndef EXEC_MEMORY_H
#include <exec/memory.h>
#endif

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif

#ifndef INTUITION_SCREENS_H
#include <intuition/screens.h>
#endif

#ifndef INTUITION_IMAGECLASS_H
#include <intuition/imageclass.h>
#endif

#ifndef INTUITION_GADGETCLASS_H
#include <intuition/gadgetclass.h>
#endif

#ifndef INTUITION_CLASSUSR_H
#include <intuition/classusr.h>
#endif

#ifndef INTUITION_CLASSES_H
#include <intuition/classes.h>
#endif

#ifndef INTUITION_ICCLASS_H
#include <intuition/icclass.h>
#endif

#ifndef GRAPHICS_GFX_H
#include <graphics/gfx.h>
#endif

#ifndef GRAPHICS_GFXBASE_H
#include <graphics/gfxbase.h>
#endif

#ifndef GRAPHICS_CLIP_H
#include <graphics/clip.h>
#endif

#ifndef GRAPHICS_LAYERS_H
#include <graphics/layers.h>
#endif

#ifndef DEVICES_KEYMAP_H
#include <devices/keymap.h>
#endif

#ifndef DEVICES_INPUTEVENT_H
#include <devices/inputevent.h>
#endif

#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif

#ifndef LIBRARIES_ASL_H
#include <libraries/asl.h>
#endif

#ifndef UTILITY_UTILITY_H
#include <utility/utility.h>
#endif

#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif

#ifndef LIBRARIES_LOCALE_H
#include <libraries/locale.h>
#endif

#ifndef DATATYPES_DATATYPES_H
#include <datatypes/datatypes.h>
#endif

#ifndef DATATYPES_DATATYPESCLASS_H
#include <datatypes/datatypesclass.h>
#endif

#ifndef DATATYPES_PICTURECLASS_H
#include <datatypes/pictureclass.h>
#endif
#include <datatypes/pictureclassext.h>

#ifndef PREFS_PREFHDR_H
#include <prefs/prefhdr.h>
#endif

#ifndef PREFS_SCREENMODE_H
#include <prefs/screenmode.h>
#endif

#ifndef PREFS_POINTER_H
#include <prefs/pointer.h>
#endif

#ifndef PREFS_INPUT_H
#include <prefs/input.h>
#endif

#ifndef PREFS_LOCALE_H
#include <prefs/locale.h>
#endif

#ifndef PREFS_FONT_H
#include <prefs/font.h>
#endif

#ifndef PREFS_PALETTE_H
#include <prefs/palette.h>
#endif

#ifndef PREFS_WBPATTERN_H
#include <prefs/wbpattern.h>
#endif
/*********************************************************************************************/

#ifndef PROTO_EXEC_H
#include <proto/exec.h>
#endif

#ifndef PROTO_DOS_H
#include <proto/dos.h>
#endif

#ifndef PROTO_INTUITION_H
#include <proto/intuition.h>
#endif

#ifndef PROTO_GRAPHICS_H
#include <proto/graphics.h>
#endif

#ifndef PROTO_UTILITY_H
#include <proto/utility.h>
#endif

#ifndef PROTO_KEYMAP_H
#include <proto/keymap.h>
#endif

#ifndef PROTO_LOCALE_H
#include <proto/locale.h>
#endif

#ifndef PROTO_LAYERS_H
#include <proto/layers.h>
#endif

#ifndef PROTO_DATATYPES_H
#include <proto/datatypes.h>
#endif

#ifndef PROTO_ALIB_H
//#include <proto/alib.h>
#endif

#include <proto/cybergraphics.h>
#include <cybergraphx/cybergraphics.h>


#ifndef PROTO_ASL_H
#include <proto/asl.h>
#endif

#ifndef PROTO_DISKFONT_H
#include <proto/diskfont.h>
#endif

#ifndef PROTO_WB_H
#include <proto/wb.h>
#endif

#ifndef PROTO_IFFPARSE_H
#include <proto/iffparse.h>
#endif

#define	D(x)	x;
#define	bug	Printf

struct PatternInfo
{
	struct BitMap	*BitMap;
	UWORD		Width;
	UWORD		Height;
	UBYTE		Flags;
	Object		*DTObject;
	char		*Name;
};

struct PatternInfo	PatternTable[WBP_SCREEN];


struct Library	*ObtainDTBase(void)
{
  if (DataTypesBase==NULL)
  {
    if (DataTypesBase=OpenLibrary("datatypes.library",0))
    {
    }
  }
  return(DataTypesBase);
}

void	ReleaseDTBase(void)
{
  if (DataTypesBase)
  {
    CloseLibrary(DataTypesBase);
    DataTypesBase	=	NULL;
  }
}

void *SetWBPrefs(ULONG,void*);
#pragma libcall WorkbenchBase SetWBPrefs 54 1002

struct BitMap	*SetImage(ULONG		Type)
{
struct BitMap *OldBitMap;

  D(bug("IPrefs_SetImage: Type %ld\n",
        Type));

  if (Type < WBP_SCREEN)
  {
    D(bug("IPrefs_SetImage: Normal WB Image\n"));
    OldBitMap	=	SetWBPrefs(1 + Type, &PatternTable[Type].BitMap);
  }
  else
  {
    D(bug("IPrefs_SetImage: Screen Image\n"));
  }
  D(bug("IPrefs_SetImage: OldBitMap 0x%lx\n",
        OldBitMap));
  return(OldBitMap);
}

void	LoadImage(struct Screen	*MyScreen,
                  ULONG		Type)
{
void			*MyObject;
struct gpLayout		gpLay;
struct BitMapHeader	*bmh = 0;
struct BitMap		*bm;

  D(bug("IPrefs_LoadImage: MyScreen 0x%lx Type %ld\n",
        MyScreen,
        Type));

  if (ObtainDTBase())
  {
    if (MyObject = NewDTObject(PatternTable[Type].Name,
                               DTA_GroupID, GID_PICTURE,
                               PDTA_Remap, FALSE,
                               PDTA_Screen, (ULONG)MyScreen,
                               PDTA_DestBitMap, (ULONG)MyScreen->RastPort.BitMap,
                               PDTA_DestMode, PMODE_V43,
                               PDTA_UseFriendBitMap, TRUE,
                               TAG_DONE))
    {
      D(bug("IPrefs_LoadImage: Object 0x%lx\n",
            MyObject));
      gpLay.MethodID	=	DTM_PROCLAYOUT;
      gpLay.gpl_GInfo	=	NULL;
      gpLay.gpl_Initial	=	1L;
      if (DoMethodA(MyObject,(Msg)&gpLay))
      {
        if (GetDTAttrs(MyObject,
                       PDTA_BitMapHeader,(ULONG)&bmh,
                       PDTA_BitMap,(ULONG)&bm,
                       NULL))
        {
          D(bug("IPrefs_LoadImage: Pattern BitMap 0x%lx\n",bm));
          D(bug("IPrefs_LoadImage: Width %ld Height %ld\n",
                bmh->bmh_Width,
                bmh->bmh_Height));

//          D(bug("IPrefs_LoadImage: BitMap Type 0x%lx\n",GetCyberMapAttr(bm,CYBRMATTR_PIXFMT)));
          PatternTable[Type].Width	=	bmh->bmh_Width;
          PatternTable[Type].Height	=	bmh->bmh_Height;
          PatternTable[Type].DTObject	=	MyObject;
          if (PatternTable[Type].BitMap = AllocBitMap(PatternTable[Type].Width,
                                                      PatternTable[Type].Height,
                                                      bmh->bmh_Depth,
                                                      BMF_MINPLANES,
                                                      MyScreen->RastPort.BitMap))
          {
            D(bug("IPrefs_LoadImage: Friend Pattern BitMap 0x%lx\n",PatternTable[Type].BitMap));
            /* a friend BitMap created...*/
#if 0
            if (MyScreen->Height != bmh->bmh_Height)
            {
              struct BitScaleArgs bsa;
              bsa.bsa_SrcX = 0;
              bsa.bsa_SrcY = 0;
              bsa.bsa_SrcWidth = PatternTable[Type].Width;
              bsa.bsa_SrcHeight = bmh->bmh_Height;
              bsa.bsa_DestX = 0;
              bsa.bsa_DestY = 0;

              bsa.bsa_XSrcFactor = 1;
              bsa.bsa_XDestFactor = 1;
              bsa.bsa_YSrcFactor = bmh->bmh_Height;
              bsa.bsa_YDestFactor = PatternTable[Type].Height;
	
              bsa.bsa_SrcBitMap = bm;
              bsa.bsa_DestBitMap = PatternTable[Type].BitMap;

              bsa.bsa_Flags = 0;
						
              D(bug("custom: scale 0x%lx\n",cbi->BitMap));
              BitMapScale(&bsa);
            }
            else
#endif
            {
              D(bug("IPrefs_LoadImage: normal blit 0x%lx\n",PatternTable[Type].BitMap));
              BltBitMap(bm,
                        0,
                        0,
                        PatternTable[Type].BitMap,
                        0,
                        0,
                        bmh->bmh_Width,
                        bmh->bmh_Height,
                        0xC0,
                        0xFF,
                        0);
            }

            if (PatternTable[Type].BitMap)
            {
              SetImage(Type);
            }
          }
          else
          {
            D(bug("IPrefs_LoadImage: can't alloc bitmap\n"));
          }
        }
        else
        {
          D(bug("IPrefs_LoadImage: can't get bitmap\n"));
        }
      }
      else
      {
        D(bug("IPrefs_LoadImage: can't layout\n"));
      }
      DisposeDTObject(MyObject);
      PatternTable[Type].DTObject = NULL;
    }
    else
    {
      D(bug("IPrefs_LoadImage: can't load <%s>\n",
            PatternTable[Type].Name));
    }
    ReleaseDTBase();
  }
  else
  {
    D(bug("IPrefs_LoadImage: can't open datatypes.library\n"));
  }
}

struct Screen	*ObtainWBScreen(void)
{
struct Screen	*MyScreen;

  MyScreen	=	LockPubScreen(NULL);

  return(MyScreen);
}

void	ReleaseWBScreen(struct Screen	*MyScreen)
{

  UnlockPubScreen(NULL,MyScreen);
}

void	main(void)
{
struct Screen *MyScreen;

  PatternTable[0].Name = "system:graphics/backdrops/00000017.jpg";
  if (MyScreen=ObtainWBScreen())
  {
    LoadImage(MyScreen,
              0);

    ReleaseWBScreen(MyScreen);
  }
}
